function  [sys, x0]  = robplot(t,x,u,flag,ax)
%SFUNXY an S-function which acts an X-Y scope using MATLAB's plotting functions.
%
%       This M-file is designed to be used in a SIMULAB S-function block.
%       It stores the last input point using discrete states 
%	and then plots this against the most recent input. 
%
%	Set this M-file up in an S-function block with a MUX with 3
%	inputs feeding into this block. Set the function parameter
%	up as a four element vector which defines the axis of the graph.
%
%	

%	Copyright (c) 1991 by the MathWorks, Inc.
%	Andrew Grace 5-30-91.
%	Modificato da :
%	Stefano Panzieri 7-15-92.

sample=0.07;

if abs(flag) == 2   	% A real time hit 

       	figure(1),clf
    	hold on
        x_pos=u(1);
        fill([-1 -1 1 1]+x_pos,[0 0.5 0.5 0],'b')
        angolo=u(2);
        l=2;
        lh=line([x_pos  x_pos+l*sin(angolo)],[0.5 0.5+l*cos(angolo)]);
        set(lh,'LineWidth',3)
        rif=u(3);
        fill([-0.5 0 0.5]+rif,[0 0.3 0],'g')
        ph=plot(x_pos+l*sin(angolo),0.5+l*cos(angolo),'ro');
        set(ph,'LineWidth',12)

        
      	axis(ax)			% Set up the axis
		hold off
        pause(0)
        drawnow

		sys = [0 0 0 0 0 0 0 0 ];         % Stato successivo




elseif flag  == 0, 	% Initialization
        sys = [0;8;0;3;0;0]; 	% System sizes - 8 discrete states, 3 inputs
        x0 = [Inf; Inf; Inf; Inf; Inf; Inf; Inf; Inf]; 	% Flag to indicate first point
	% Initialize graph
	figure(1),clf
	hold on

	plot(0,0,'o'),grid  	% Force a circle to be drawn
    x_pos=0;
    fill([-1 -1 1 1]+x_pos,[0 0.5 0.5 0],'b')
    angolo=0;
    l=2;
    lh=line([x_pos  x_pos+l*sin(angolo)],[0.5 0.5+l*cos(angolo)]);
    set(lh,'LineWidth',3)
    rif=0;
    fill([-0.5 0 0.5]+rif,[0 0.3 0],'r')
    ph=plot(x_pos+l*sin(angolo),0.5+l*cos(angolo),'ro');
    set(ph,'LineWidth',12)
    
  	axis(ax)			% Set up the axis

elseif flag == 4,  % Next discrete update
	
       	%sys=ceil(t/sample+sample/1e8)*sample;
        sys=t+sample;

else
        sys = [];
end
